#!/user/bin/perl

sub pack_stone{
	my ($col,$row,$orientation,$red,$length) = @_;
#	print	"$red $col $row $orientation $length ";
	
#Komprimierung:
#1 Byte pro Teil.
#3 bit zeile 3 bit spalte 1 bit w/s, 1 bit 2/3, 1. Zeichen ist das rote Teil

	print "length-error $length\n" unless $length ~~ [2,3];

	my $bits = reverse
		unpack ('b1', chr($length-2))
		. unpack ('b1', chr($orientation))
		. unpack ('b3', chr($row))
		. unpack ('b3', chr($col));
	
#print $bits, " ", oct('0b'.$bits), "\n";	
#print pack ('B*', $bits), "\n";

if ($red == 1) { $out = pack('B*', $bits) . $out } else { $out .= pack ('B*', $bits) }
}


my @counts = (50, 30, 20, 10);
my @counts = (400, 300, 200, 100);

$ARGV[0] ||= 'puzzles.tsv';

open IN,"$ARGV[0]";
open OUT, ">$ARGV[0].rom";
binmode OUT;

print OUT pack('SSSS', @counts);	

while (<IN>)  {
	chomp;
	my ($puzzle, $board)=split ';';
	#print $puzzle, $board, "\n";
	my ($nr, $pack, $minmove) =split ',', $puzzle;
	# print "$nr, $pack, $minmove\n";

	next if $nr >= $counts[$pack];
	last if $pack > 3;

	my @board = split ' ', $board;
	print "NR $nr, $pack, $minmove, $#board\n";
	#for ($i=0;$i<=$#board;$i++) { print "$board[$i]-" } print "\n";

	#last if $pack > 0;
	#last if $nr > 1000;
	
	$out='';
	for ($i=0;$i<=$#board;$i++) {
		pack_stone(split ',', $board[$i]);
	}
	print	unpack('H*',$out."\xFF"), "\n";
	print OUT $out, "\xFF";
} 	
close IN;
close OUT;


__END__

0,0,1,0,3
1,1,1,0,2
4,1,1,0,2
1,2,1,1,2
3,3,1,0,2
0,5,1,0,3
0,1,0,0,3
2,3,0,0,2
3,0,0,0,3
4,4,0,0,2
5,2,0,0,3



#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------

1. Spalte 0..5				Spalte 0..5
2. Spalte 0..5				Zeile	0..5
3. Spalte erst nur 1en, dann nur 0en	1=waagerecht nach rechts, 2=senkrecht nach unten
4. Spalte 0, nur 1x 1			0=holz, 1=rot
5. Spalte 2/3				lnge


Komprimierung:
1 Byte pro Teil.
3 bit zeile 3 bit spalte 1 bit w/s, 1 bit 2/3, 1. Zeichen ist das rote Teil
